#!/usr/bin/perl
#
# (c) astx (at) aws-it.at, 2018
#
# $Id: generate_rms_power_dissipation_script.pl 1543 2018-12-28 21:03:43Z sta $
#

use strict;
my $s=0;
my $devs={};
my @lines;
open(INP, "< $ARGV[0]") && do {
	while (my $line=<INP>) {
		chomp($line);
		if ($line =~ /^.*Begin SPICE netlist of main design.*/) {
			$s=1;
		}
		if ($s) {
			# known devices:
			my $d=lc($line);
			if ($d=~/^([rdclmq][a-z]*)([0-9]+)\s+/) {
				my $dtyp="$1";
				my $num="$2";
				$devs->{"$dtyp"}{"$num"}=$d;
			}
		}
	}
	close(INP);
};

foreach my $dtyp (sort keys %{$devs}) {
	foreach my $num (sort {$a<=>$b} keys %{$devs->{$dtyp}}) {
		push(@lines, "$devs->{$dtyp}{$num}");
	}
}

	print "\n.control\n";
	foreach my $line (@lines) {
		my $d=lc($line);
		if ($d=~/^([rdcl][^\s]+)\s+([^\s]+)\s+([^\s]+)\s+/) {
			my $dev="$1";
			my $n1="$2";
			my $n2="$3";
			# DEV r2 connected via pgnd and 0
			print STDERR "DEV $dev connected via $n1 and $n2\n";
			my $c='i';
			# diode has other current var name
			if ($dev=~/^d/) {
				$c='id';
			}
			if ($n1 eq '0' || $n2 eq '0') {
				if ($n1 eq '0') {
					print "let p_$dev = abs(v($n2)*\@$dev\[$c\])\n";
				} else {
					print "let p_$dev = abs(v($n1)*\@$dev\[$c\])\n";
				}
				print "meas tran pwr_rms_$dev RMS p_$dev\n";
				} else {
				print "let p_$dev = abs(v($n1,$n2)*\@$dev\[$c\])\n";
				print "meas tran pwr_rms_$dev RMS p_$dev\n";
			}
		}
		if ($d=~/^([mq][^\s]+)\s+([^\s]+)\s+([^\s]+)\s+([^\s]+)\s+/) {
			my $dev=$1;
			my $n1=$2;
			my $n2=$3;
			my $n3=$4;

			my $c='ie';
			# mosfet has other current var name
			if ($dev=~/^m/) {
				$c='id';
			}
			if ($n1 eq '0' || $n2 eq '0') {
				if ($n1 eq '0') {
					print "let p_$dev = abs(v($n2)*\@$dev\[$c\])\n";
				} else {
					print "let p_$dev = abs(v($n1)*\@$dev\[$c\])\n";
				}
				print "meas tran pwr_rms_$dev RMS p_$dev\n";
				} else {
				print "let p_$dev = abs(v($n1,$n2)*\@$dev\[$c\])\n";
				print "meas tran pwr_rms_$dev RMS p_$dev\n";
			}
			print STDERR "DEV $dev connected via $n1 and $n2 and $n3\n";
		}
	}
	print "\n.endc\n";
